/**
 * Copyright (C) 2009-2011 enStratusNetworks LLC
 *
 * ====================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ====================================================================
 */

package org.dasein.cloud.compute;

import javax.annotation.Nullable;

public interface ComputeServices {
    public abstract @Nullable AutoScalingSupport getAutoScalingSupport();
    
    public abstract @Nullable MachineImageSupport getImageSupport();
    
    public abstract @Nullable SnapshotSupport getSnapshotSupport();
    
    public abstract @Nullable VirtualMachineSupport getVirtualMachineSupport();
    
    public abstract @Nullable VolumeSupport getVolumeSupport();
    
    public abstract boolean hasAutoScalingSupport();
    
    public abstract boolean hasImageSupport();
    
    public abstract boolean hasSnapshotSupport();
    
    public abstract boolean hasVirtualMachineSupport();
    
    public abstract boolean hasVolumeSupport();
}
